// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QExport3RTFList.pas' rev: 5.00

#ifndef QExport3RTFListHPP
#define QExport3RTFListHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Graphics.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <QExport3.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qexport3rtflist
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TRTFHeader;
class PASCALIMPLEMENTATION TRTFHeader : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FDefaultFont;
	int FVersion;
	int FDefaultTab;
	AnsiString FCode;
	int __fastcall GetSize(void);
	
public:
	__fastcall TRTFHeader(int AVersion, const AnsiString ACode, int ADefaultFont, int ADefaultTab);
	__property int Version = {read=FVersion, write=FVersion, nodefault};
	__property AnsiString Code = {read=FCode, write=FCode};
	__property int DefaultFont = {read=FDefaultFont, write=FDefaultFont, nodefault};
	__property int DefaultTab = {read=FDefaultTab, write=FDefaultTab, nodefault};
	__property int Size = {read=GetSize, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TRTFHeader(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRTFFontTableItem;
class PASCALIMPLEMENTATION TRTFFontTableItem : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FFontNumber;
	AnsiString FFontFamily;
	AnsiString FFontName;
	void __fastcall SetFontFamily(const AnsiString Value);
	void __fastcall SetFontName(const AnsiString Value);
	void __fastcall SetFontNumber(const int Value);
	int __fastcall GetSize(void);
	AnsiString __fastcall GetAsText();
	
public:
	__fastcall TRTFFontTableItem(int ANumber, const AnsiString AFamily, const AnsiString AName);
	__property int FontNumber = {read=FFontNumber, write=SetFontNumber, nodefault};
	__property AnsiString FontFamily = {read=FFontFamily, write=SetFontFamily};
	__property AnsiString FontName = {read=FFontName, write=SetFontName};
	__property int Size = {read=GetSize, nodefault};
	__property AnsiString AsText = {read=GetAsText};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TRTFFontTableItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRTFFontTable;
class PASCALIMPLEMENTATION TRTFFontTable : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	void __fastcall FreeAll(void);
	TRTFFontTableItem* __fastcall GetFontItems(int index);
	void __fastcall SetFontItems(int index, const TRTFFontTableItem* Value);
	int __fastcall GetSize(void);
	
public:
	__fastcall virtual ~TRTFFontTable(void);
	int __fastcall GetFontIndexByName(const AnsiString FontName);
	__property TRTFFontTableItem* FontItems[int index] = {read=GetFontItems, write=SetFontItems/*, default
		*/};
	__property int Size = {read=GetSize, nodefault};
	int __fastcall GetNextNumber(void);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TRTFFontTable(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TRTFColorTableItem;
class PASCALIMPLEMENTATION TRTFColorTableItem : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FRed;
	int FGreen;
	int FBlue;
	int __fastcall GetSize(void);
	AnsiString __fastcall GetAsText();
	Graphics::TColor __fastcall GetColor(void);
	
public:
	__fastcall TRTFColorTableItem(int ARed, int AGreen, int ABlue)/* overload */;
	__fastcall TRTFColorTableItem(Graphics::TColor Color)/* overload */;
	__property int Red = {read=FRed, write=FRed, nodefault};
	__property int Green = {read=FGreen, write=FGreen, nodefault};
	__property int Blue = {read=FBlue, write=FBlue, nodefault};
	__property Graphics::TColor Color = {read=GetColor, nodefault};
	__property AnsiString AsText = {read=GetAsText};
	__property int Size = {read=GetSize, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TRTFColorTableItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRTFColorTable;
class PASCALIMPLEMENTATION TRTFColorTable : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	void __fastcall FreeAll(void);
	TRTFColorTableItem* __fastcall GetColors(int index);
	void __fastcall SetColors(int index, const TRTFColorTableItem* Value);
	int __fastcall GetSize(void);
	int __fastcall GetColorIndex(Graphics::TColor Color);
	
public:
	__fastcall virtual ~TRTFColorTable(void);
	__property TRTFColorTableItem* Colors[int index] = {read=GetColors, write=SetColors/*, default*/};
	__property int Size = {read=GetSize, nodefault};
	int __fastcall GetNextNumber(void);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TRTFColorTable(void) : Classes::TList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TrtfColorType { ctText, ctBackground, ctHighlight };
#pragma option pop

class DELPHICLASS TQRTFWriter;
class PASCALIMPLEMENTATION TQRTFWriter : public Qexport3::TQExportWriter 
{
	typedef Qexport3::TQExportWriter inherited;
	
private:
	TRTFHeader* FHeader;
	TRTFFontTable* FFontTable;
	TRTFColorTable* FColorTable;
	void __fastcall SetHeader(const TRTFHeader* Value);
	
public:
	__fastcall virtual TQRTFWriter(Qexport3::TQExport3* AOwner, Classes::TStream* AStream);
	__fastcall virtual ~TQRTFWriter(void);
	void __fastcall WriteBOF(void);
	void __fastcall WriteEOF(void);
	void __fastcall WritePara(void);
	void __fastcall WriteHeader(void);
	void __fastcall WriteFontTable(void);
	void __fastcall WriteColorTable(void);
	void __fastcall AddFont(TRTFFontTableItem* AFont);
	void __fastcall AddColor(TRTFColorTableItem* AColor);
	void __fastcall SetFont(Graphics::TFont* Font, bool NeedWrite, AnsiString &FontStr);
	AnsiString __fastcall GetFontText(Graphics::TFont* Font, bool Local);
	AnsiString __fastcall GetColorText(Graphics::TColor Color, TrtfColorType ColorType);
	__property TRTFHeader* Header = {read=FHeader, write=SetHeader};
	void __fastcall Insert(int APosition, const void *Buffer, int Count);
	virtual AnsiString __fastcall AlignToStr(Qexport3::TQExportColAlign Value);
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Qexport3rtflist */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qexport3rtflist;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QExport3RTFList
